/*--------------------------------------------------------------*\
		module	:	HOOK.c
		purpose :	CALLWNDtbN
		author	:	_@ Kengo Jinno
		create	:	1999/12/03
		update	:	1999/12/03
					2000/10/31	eŏ́AXN[̒S
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"HOOK.h"

/*
	CALLWNDPROCtbNB
	ʐM|[g/{[Cg_CAOMessageBox()̃_CAOA
	CEBhE̒ɕ\߁B
	
	SetWindowsHookEx() UnhookWindowsHookEx() CallNextHookEx()
	Windows3.1ȍ~̊֐Ȃ̂ŁA3.0ł͎gȂB
	SetWindowsHook() UnhookWindowsHook() DefHookProc()3.0ł
	g邪AO[otbNłȂ݂Ȃ̂ł߂B
	
	WINVER0x0300ɂĂ܂...Ex()͎gȂB
	WINVER0x030â܂܁Arc /30悤ɂB
	sɂGetVersion()Ń`FbNĂ̂ŁA3.0
	...Ex()Ă΂邱Ƃ͂ȂB
	u[vWIN31WH.HLPɏĂB
*/

static	HHOOK	hHook = NULL;	/*	tbNvV[W	*/
#ifndef	WIN32
static	FARPROC	hkProc = NULL;	/*	tbNvV[W	*/
#endif

#ifndef	WIN32
typedef struct tagCWPSTRUCT { /* cwps */
	LPARAM	lParam;
	WPARAM	wParam;
	UINT	message;
	HWND	hwnd;
} CWPSTRUCT;
#endif

/*	tbNvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyCallWndProc( int nCode, WPARAM wParam, LPARAM lParam )
{
#if (WINVER >= 0x030a)
	CWPSTRUCT*	cwps = (CWPSTRUCT*)lParam;
	if( nCode >= 0 && cwps->message == WM_INITDIALOG ) {
		/*	_CAOeEBhE̒SɎĂ	*/
		HWND	hWnd = cwps->hwnd;
		HWND	hParent = GetParent( hWnd );
		RECT	rectParent, rect, rectScreen;
		int		x, y;
		if( hParent == NULL || IsIconic( hParent ) ) {
			hParent = GetDesktopWindow();
		}
		GetWindowRect( hParent, &rectParent );
		GetWindowRect( hWnd, &rect );
		rectScreen.left = 0;
		rectScreen.top = 0;
		rectScreen.right = GetSystemMetrics(SM_CXSCREEN);
		rectScreen.bottom = GetSystemMetrics(SM_CYSCREEN);
		x = ( rectParent.left + rectParent.right ) / 2 - ( rect.right - rect.left ) / 2;
		y = ( rectParent.top + rectParent.bottom ) / 2 - ( rect.bottom - rect.top ) / 2;
		if( x < 0 ) {
			x = 0;
		} else if ( x + rect.right - rect.left > rectScreen.right ) {
			x = rectScreen.right - ( rect.right - rect.left );
		}
		if( y < 0 ) {
			y = 0;
		} else if( y + rect.bottom - rect.top > rectScreen.bottom ) {
			y = rectScreen.bottom - ( rect.bottom - rect.top );
		}
		SetWindowPos( hWnd, NULL, x, y, 0, 0, SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
	}
	return CallNextHookEx( hHook, nCode, wParam, lParam );
#else
	return 0L;
#endif
}

/*	tbNݒ肷	*/
void	InstallHook( HINSTANCE hInstance )
{
#if (WINVER >= 0x030a)
	if( hHook == NULL ) {
#ifdef	WIN32
		hHook = SetWindowsHookEx( WH_CALLWNDPROC, MyCallWndProc, NULL, GetCurrentThreadId() );
#else
		UINT	uVersion = LOWORD( GetVersion() );
		if( ( (LOBYTE(uVersion)<<8) | HIBYTE(uVersion) ) >= 0x030a ) {
			/*	3.1ȍ~̂	*/
			hkProc = MakeProcInstance( (FARPROC)MyCallWndProc, hInstance );
			hHook = SetWindowsHookEx( WH_CALLWNDPROC, (HOOKPROC)hkProc, hInstance, GetCurrentTask() );
		}
#endif
	}
#endif
}

/*	tbN	*/
void	RemoveHook( void )
{
#if (WINVER >= 0x030a)
	if( hHook != NULL ) {
		UnhookWindowsHookEx( hHook );
		hHook = NULL;
	}
#ifndef	WIN32
	if( hkProc != NULL ) {
		FreeProcInstance( hkProc );
		hkProc = NULL;
	}
#endif
#endif
}
