/*--------------------------------------------------------------*\
		module	:	MySocket.h
		purpose :	ȒPt@C] \Pbg֌W
		author	:	_@ Kengo Jinno
		create	:	2011/02/25
		update	:	2011/03/11
\*--------------------------------------------------------------*/

#ifndef	MYSOCKET_H
#define	MYSOCKET_H

#if		defined(__BORLANDC__)
#pragma option	push	-a2
#endif

typedef	struct	tagMySocketInfoType	{
	BOOL	bListen;		/*	listen(==T[o)	*/
	SOCKET	hSocket;		/*	̃\Pbgnh	*/
	SOCKET	hSockClient;	/*	NCAg	*/
	TCHAR	szSendTo[ _MAX_PATH ];	/*	M	*/
	UINT	uPort;			/*	|[gԍ	*/
	BOOL	bCleanUp;		/*	CleanUp	*/
	UINT	uAsyncMsg;		/*	ʒmbZ[W	*/
	DWORD	dwErrorCode;	/*	G[R[h	*/
	UINT	uErrorID;		/*	G[ID(񃊃\[X)	*/
	
	HGLOBAL		hMsgBuff;	/*	Mobt@	*/
	DWORD		dwBuffLen;	/*	mۍς݃obt@̑傫	*/
	DWORD		dwRecvLen;	/*	Mς݃TCY	*/
	
	int			nClientState;	/*	NCAg̃Xe[^X	*/
	
}	MySocketInfo, NEAR* NpMySocketInfo;

#define	MSG_C2S_FILEINFO	0
#define	MSG_C2S_CONTENT		1
#define	MSG_C2S_FILEATTR	2

/*	NCAgT[oւ̃bZ[W	*/
typedef	struct	tagMyClient2ServerMsgType	{
	DWORD	dwMagic;		/*	}WbNio[	*/
	WORD	wMsgType;		/*		*/
	union	{
		struct	{
			DWORD	dwSizeHigh;
			DWORD	dwSizeLow;
			TCHAR	szFileName[ _MAX_FNAME ];
		}	sFileInfo;
		struct	{
			WORD	wSize;
			BYTE	data[ 256 ];
		}	sFileContent;
		struct	{
			WORD	wYear;
			WORD	wMonth;
			WORD	wDayOfWeek;
			WORD	wDay;
			WORD	wHour;
			WORD	wMinute;
			WORD	wSecond;
			WORD	wMilliseconds;
			BYTE	md5[ 16 ];
		}	sFileAttr;
	}	uMsgBody;
}	MyClient2ServerMsg, NEAR* NpMyClient2ServerMsg;

#define	MSG_S2C_ACK		0
#define	MSG_S2C_NAK		1

/*	T[oNCAgւ̃bZ[W	*/
typedef	struct	tagMyServer2ClientMsgType	{
	DWORD	dwMagic;		/*	}WbNio[	*/
	WORD	wAnswer;
}	MyServer2ClientMsg, NEAR* NpMyServer2ClientMsg;


/*	NCAg̃Xe[^X	*/
#define	STATE_CLIENT_NONE		0	/*	ĂȂ	*/
#define	STATE_CLIENT_CONN		1	/*	connect()ĉ҂	*/
#define	STATE_CLIENT_INFO		2	/*	t@C𑗂ĉ҂	*/
#define	STATE_CLIENT_CONTENT	3	/*	t@C̓e𑗐M	*/
#define	STATE_CLIENT_ATTR		4	/*	𑗂ĉ҂	*/

#define	WM_MY_CLIENT_MSG	(WM_APP+31)
/*
	wParam = G[̃Xe[^X
*/

#define	WM_MY_SERVER_MSG	(WM_APP+33)

#define	WM_MY_SOCKET_NOTIFY	(WM_APP+35)

#define	WM_MY_RESULT_NOTIFY	(WM_APP+37)
/*
	wParam = ʃR[h(񃊃\[X)
	lParam = ʃx(AG[)
*/

#ifdef	__cplusplus
extern "C" {
#endif

extern	BOOL	InitMySocket( HWND hWnd, NpMySocketInfo pInfo );
extern	BOOL	StartMySocket( HWND hWnd, NpMySocketInfo pInfo );
extern	BOOL	QuitMySocket( HWND hWnd, NpMySocketInfo pInfo );
extern	BOOL	OpenMySocket( HWND hWnd, NpMySocketInfo pInfo );
extern	BOOL	CloseMySocket( HWND hWnd, NpMySocketInfo pInfo );
extern	BOOL	IsOpenedMySocket( NpMySocketInfo pInfo );
extern	BOOL	IsExistClientMySocket( NpMySocketInfo pInfo );
extern	BOOL	CloseClientMySocket( HWND hWnd, NpMySocketInfo pInfo );

extern	void	MySockerMsgProc( HWND hWnd, WPARAM wParam, LPARAM lParam, NpMySocketInfo pInfo );

extern	BOOL	RecvMySocket( SOCKET hSocket, LPBYTE pBuff, DWORD dwSize, LPDWORD lpdwReadCnt );
extern	BOOL	SendMySocket( SOCKET hSocket, const LPBYTE pBuff, DWORD dwSize );

extern	BOOL	SendS2cMsg( SOCKET hSocket, WORD wAnswer );
extern	BOOL	SendC2sMsg( SOCKET hSocket, NpMyClient2ServerMsg p, WORD type );

extern	BOOL	GetPeerName( NpMySocketInfo pInfo, LPTSTR pBuff );

#ifdef	__cplusplus
}
#endif

#if		defined(__BORLANDC__)
#pragma	option	pop
#endif

#endif	/*	MYSOCKET_H	*/
