/*--------------------------------------------------------------*\
		module	:	Progress.c
		purpose :	ȒPt@C] vOXo[
		author	:	_@ Kengo Jinno
		create	:	2011/03/14
		update	:	2011/04/19
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"Progress.h"
#include	"resource.h"


#define	STEP_1		5
#define	STEP_2		5
#define	STEP_RATE	100

#define	TOTAL_RANGE	(STEP_1+STEP_2+STEP_RATE)

/*
	range = 5 + 5 + 100
	̂ PROGRESS_STEP_1  5
	         PROGRESS_STEP_2  5
	c 100 t@C{(100)
*/

void	InitProgressRange( HWND hDlg )
{
	SendDlgItemMessage( hDlg, IDC_PROGRESS_PROCESS, PBM_SETRANGE, 0, MAKELPARAM(0,TOTAL_RANGE) );
	SendDlgItemMessage( hDlg, IDC_PROGRESS_PROCESS, PBM_SETPOS, 0, 0 );
}

int		ResetProgressPos( HWND hDlg )
{
	SendDlgItemMessage( hDlg, IDC_PROGRESS_PROCESS, PBM_SETPOS, 0, 0 );
	return( 0 );
}

void	DoProgressStep( HWND hDlg, int nStep )
{
	int		pos;
	if( nStep == PROGRESS_STEP_1 ) {
		pos = STEP_1;
		SendDlgItemMessage( hDlg, IDC_PROGRESS_PROCESS, PBM_SETPOS, pos, 0 );
	} else if( nStep == PROGRESS_STEP_2 ) {
		pos = STEP_1 + STEP_2;
		SendDlgItemMessage( hDlg, IDC_PROGRESS_PROCESS, PBM_SETPOS, pos, 0 );
	}
}

int		SetProgressPos( HWND hDlg, int nPos, DWORD dwSizeTotal, DWORD dwSizeRemain )
{
	int		pos;
	pos = MulDiv( STEP_RATE, dwSizeTotal - dwSizeRemain, dwSizeTotal );
	if( nPos != pos ) {
		nPos = pos;
		pos += STEP_1 + STEP_2;
		SendDlgItemMessage( hDlg, IDC_PROGRESS_PROCESS, PBM_SETPOS, pos, 0 );
	}
	return( nPos );
}

void	MaxProgressPos( HWND hDlg )
{
	SendDlgItemMessage( hDlg, IDC_PROGRESS_PROCESS, PBM_SETPOS, TOTAL_RANGE, 0 );
}
