/*--------------------------------------------------------------*\
		module	:	SFT.h
		purpose :	ȒPt@C] C
		author	:	_@ Kengo Jinno
		create	:	2011/02/21
		update	:	2011/04/19
\*--------------------------------------------------------------*/

#ifndef	SFT_H
#define	SFT_H

#include	"bccres.h"
#include	"resource.h"
#include	"MySocket.h"
#include	"md5.h"

/*	PathSetDlgItemPath() (shlwapi.dll)ւ̃|C^^	*/
typedef	void	(WINAPI FAR* LP_FUNC_PATHSETDLGITEMPATH)( HWND, int, LPCSTR );

typedef	struct	tagSftInfo	{
	HINSTANCE	hInstance;		/*	g̃CX^Xnh	*/
	
	HICON		hLargeIcon;		/*	傫ACR	*/
	HICON		hSmallIcon;		/*	ACR	*/
	
	TCHAR		szAppTitle[80];	/*	LvV	*/
	int			nMode;			/*	MHMH	*/
	
	TCHAR		szProfile[_MAX_PATH];		/*	INIt@C̃pX	*/
	TCHAR		szInitialDir[_MAX_PATH];	/*	OpenFile_CAȌfBNg	*/
	TCHAR		szFilePath[_MAX_PATH];		/*	It@C̃tpX	*/
	TCHAR		szFileName[_MAX_FNAME];		/*	It@C̃t@C	*/
	TCHAR		szSaveFilePath[_MAX_PATH];	/*	Mt@CۑtpX	*/
	
	HINSTANCE	hInstShlWapiDll;	/*	shlwapi.dll̃CX^Xnh	*/
	LP_FUNC_PATHSETDLGITEMPATH	lpPathSetDlgItemPath;	/*	PathSetDlgItemPath()	*/
	
	HWND		hWndToolTip;	/*	c[`bv	*/
	
	HFONT		hFontMsg;		/*	bZ[WptHg	*/
	
	/*	\Pbg֌W	*/
	MySocketInfo	SocketInfo;
	
	/*	t@CM	*/
	HANDLE	hFile;
	DWORD	dwSizeRemain;
	DWORD	dwSizeTotal;
	int		nProgressPos;
	
	MD5_CTX	md5context;
	
}	SftInfo, NEAR* NpSftInfo;

#define	GWL_SFT_INFO		DLGWINDOWEXTRA

#define	SFT_EXTRA_BYTES		sizeof(LONG)
#define	GetSftInfo(x)		( (NpSftInfo)GetWindowLong(x,GWL_SFT_INFO) )
#define	SetSftInfo(x,y)		SetWindowLong(x,GWL_SFT_INFO,(LONG)y)

/*	MHMH	*/
#define	SFT_MODE_NONE		0
#define	SFT_MODE_SEND		1
#define	SFT_MODE_RECV		2

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif

#endif	/*	SFT_H	*/
