/*--------------------------------------------------------------*\
		module	:	ToolTip.h
		purpose :	ȒPt@C] c[`bv
		author	:	_@ Kengo Jinno
		create	:	2001/09/18
		update	:	2001/10/17
					2001/11/13	CreateMyToolTip()ɈbSubclass
								ǉATTF_SUBCLASS̎gp𔻒f
					2001/11/13	RelayEventMyToolTip()ǉ
\*--------------------------------------------------------------*/

#ifndef	TOOLTIP_H
#define	TOOLTIP_H

/*	IE3TOOLINFO	*/
typedef struct tagOldTOOLINFO {
	UINT		cbSize;
	UINT		uFlags;
	HWND		hwnd;
	UINT		uId;
	RECT		rect;
	HINSTANCE	hinst;
	LPTSTR		lpszText;
} oldTOOLINFO;


typedef	struct	tagToolTipDataType	{
	UINT	iWndID;		/*	EBhEID	*/
	UINT	iStringID;	/*	XgO\[XID	*/
}	ToolTipDataType, FAR* LpToolTipDataType;

/*	s̏ꍇ̍ő啶	*/
#define	MAX_MY_TOOLTIP_TEXT		512

typedef	struct	tagTooTipInfoType	{
	WNDPROC	lpfnOldWndProc;
	TCHAR	szTooltipText[ MAX_MY_TOOLTIP_TEXT ];
}	ToolTipInfoType, FAR* LpToolTipInfoType;

#ifdef	__cplusplus
extern "C" {
#endif

/*	c[`bv쐬	*/
extern	HWND	CreateMyToolTip( HWND hWndParent, const LpToolTipDataType pData, int nCnt, BOOL bMultiline, BOOL bSubclass );

/*	c[`bv쐬(Xe[^Xo[p)	*/
extern	HWND	CreateMyStatusBarToolTip( HWND hWndParent, const LpToolTipDataType pData, int nCnt, BOOL bMultiline );

/*	c[`bvj	*/
extern	BOOL	DestroyMyToolTip( HWND hWnd );

/*	TuNXvV[W	*/
extern	LRESULT	MYEXPORT	CALLBACK	MyToolTipWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

/*	̗v	*/
extern	void	NeedTextMyToolTip( HWND hWnd, HINSTANCE hInstance, LPTOOLTIPTEXT lptip );

/*	s	*/
extern	void	DoMultilineMyToolTip( HWND hWnd );

/*	}EXbZ[W	*/
extern	void	RelayEventMyToolTip( HWND hWnd, LPMSG lpmsg );

#ifdef	__cplusplus
}
#endif

#endif	/*	TOOLTIP_H	*/
